%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                           PSG Type    PSG Object                  Location in Problem Statement                      Class
%matrix_scenarios_benchmark       bench       matrix_scenarios            meanabs_dev(matrix_scenarios)                      double
%matrix_scenarios_data            data        matrix_scenarios            meanabs_dev(matrix_scenarios)                      double
%matrix_scenarios_vars            vars        matrix_scenarios            meanabs_dev(matrix_scenarios)                      cell
%matrix_constraint_budget_data    data        matrix_constraint_budget    polynom_abs(matrix_constraint_budget)              double
%matrix_constraint_budget_vars    vars        matrix_constraint_budget    polynom_abs(matrix_constraint_budget)              cell
%point_lowerbounds_data           data        point_lowerbounds           Box: >= point_lowerbounds, <= point_upperbounds    double
%point_lowerbounds_vars           vars        point_lowerbounds           Box: >= point_lowerbounds, <= point_upperbounds    cell
%point_upperbounds_data           data        point_upperbounds           Box: >= point_lowerbounds, <= point_upperbounds    double
%point_upperbounds_vars           vars        point_upperbounds           Box: >= point_lowerbounds, <= point_upperbounds    cell
%parameter_bound_data             data        parameter_bound             Constraint: <= parameter_bound, linearize = 1      double
%parameter_solver_data            data        parameter_solver            Solver: parameter_solver                           char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_scenarios_benchmark,matrix_scenarios_data,matrix_scenarios_vars,matrix_constraint_budget_data,matrix_constraint_budget_vars,point_lowerbounds_data,point_lowerbounds_vars,point_upperbounds_data,point_upperbounds_vars,parameter_bound_data,parameter_solver_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_scenarios',matrix_scenarios_data,matrix_scenarios_vars,matrix_scenarios_benchmark,[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_constraint_budget',matrix_constraint_budget_data,matrix_constraint_budget_vars,[],[]);
count = count+1;
iargstruc_arr(count) = point_pack('point_lowerbounds',point_lowerbounds_data,point_lowerbounds_vars);
count = count+1;
iargstruc_arr(count) = point_pack('point_upperbounds',point_upperbounds_data,point_upperbounds_vars);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  meanabs_dev(matrix_scenarios)',...
'Constraint: <= parameter_bound, linearize = 1',...
'  polynom_abs(matrix_constraint_budget)',...
'Box: >= point_lowerbounds, <= point_upperbounds',...
'Solver: parameter_solver',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_solver',parameter_solver_data);
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

